Index: uspace/lib/device/src/bd_srv.c
===================================================================
--- uspace/lib/device/src/bd_srv.c	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/lib/device/src/bd_srv.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2012 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -56,4 +56,5 @@
 	ipc_call_t rcall;
 	if (!async_data_read_receive(&rcall, &size)) {
+		async_answer_0(&rcall, EINVAL);
 		async_answer_0(call, EINVAL);
 		return;
@@ -99,4 +100,5 @@
 	ipc_call_t rcall;
 	if (!async_data_read_receive(&rcall, &size)) {
+		async_answer_0(&rcall, EINVAL);
 		async_answer_0(call, EINVAL);
 		return;
Index: uspace/lib/device/src/io/chardev_srv.c
===================================================================
--- uspace/lib/device/src/io/chardev_srv.c	(revision eda4323867bf5a8e98aa598c3cca1e3fb59f4e7a)
+++ uspace/lib/device/src/io/chardev_srv.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2014 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -55,4 +55,5 @@
 	ipc_call_t call;
 	if (!async_data_read_receive(&call, &size)) {
+		async_answer_0(&call, EINVAL);
 		async_answer_0(icall, EINVAL);
 		return;
Index: uspace/lib/dispcfg/doc/doxygroups.h
===================================================================
--- uspace/lib/dispcfg/doc/doxygroups.h	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
+++ uspace/lib/dispcfg/doc/doxygroups.h	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -0,0 +1,3 @@
+/** @addtogroup libdispcfg libdispcfg
+ * @ingroup libs
+ */
Index: uspace/lib/dispcfg/include/dispcfg.h
===================================================================
--- uspace/lib/dispcfg/include/dispcfg.h	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
+++ uspace/lib/dispcfg/include/dispcfg.h	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -0,0 +1,55 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libwndmgt
+ * @{
+ */
+/** @file
+ */
+
+#ifndef _LIBDISPCFG_DISPCFG_H_
+#define _LIBDISPCFG_DISPCFG_H_
+
+#include <errno.h>
+#include <types/common.h>
+#include "types/dispcfg.h"
+
+extern errno_t dispcfg_open(const char *, dispcfg_cb_t *, void *, dispcfg_t **);
+extern void dispcfg_close(dispcfg_t *);
+extern errno_t dispcfg_get_seat_list(dispcfg_t *, dispcfg_seat_list_t **);
+extern void dispcfg_free_seat_list(dispcfg_seat_list_t *);
+extern errno_t dispcfg_get_seat_info(dispcfg_t *, sysarg_t,
+    dispcfg_seat_info_t **);
+extern void dispcfg_free_seat_info(dispcfg_seat_info_t *);
+extern errno_t dispcfg_seat_create(dispcfg_t *, const char *, sysarg_t *);
+extern errno_t dispcfg_seat_delete(dispcfg_t *, sysarg_t);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/dispcfg/include/dispcfg_srv.h
===================================================================
--- uspace/lib/dispcfg/include/dispcfg_srv.h	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
+++ uspace/lib/dispcfg/include/dispcfg_srv.h	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -0,0 +1,66 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libdispcfg
+ * @{
+ */
+/** @file
+ */
+
+#ifndef _LIBDISPCFG_DISPCFG_SRV_H_
+#define _LIBDISPCFG_DISPCFG_SRV_H_
+
+#include <async.h>
+#include <errno.h>
+#include "types/dispcfg.h"
+
+typedef struct dispcfg_ops dispcfg_ops_t;
+
+/** Display configuration server structure (per client session) */
+typedef struct {
+	async_sess_t *client_sess;
+	dispcfg_ops_t *ops;
+	void *arg;
+} dispcfg_srv_t;
+
+struct dispcfg_ops {
+	errno_t (*get_seat_list)(void *, dispcfg_seat_list_t **);
+	errno_t (*get_seat_info)(void *, sysarg_t, dispcfg_seat_info_t **);
+	errno_t (*seat_create)(void *, const char *, sysarg_t *);
+	errno_t (*seat_delete)(void *, sysarg_t);
+	errno_t (*get_event)(void *, dispcfg_ev_t *);
+};
+
+extern void dispcfg_conn(ipc_call_t *, dispcfg_srv_t *);
+extern void dispcfg_srv_initialize(dispcfg_srv_t *);
+extern void dispcfg_srv_ev_pending(dispcfg_srv_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/dispcfg/include/ipc/dispcfg.h
===================================================================
--- uspace/lib/dispcfg/include/ipc/dispcfg.h	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
+++ uspace/lib/dispcfg/include/ipc/dispcfg.h	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -0,0 +1,56 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libdispcfg
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBDISPCFG_IPC_DISPCFG_H
+#define LIBDISPCFG_IPC_DISPCFG_H
+
+#include <ipc/common.h>
+
+typedef enum {
+	DISPCFG_CALLBACK_CREATE = IPC_FIRST_USER_METHOD,
+	DISPCFG_GET_SEAT_LIST,
+	DISPCFG_GET_SEAT_INFO,
+	DISPCFG_SEAT_CREATE,
+	DISPCFG_SEAT_DELETE,
+	DISPCFG_GET_EVENT,
+} dispcfg_request_t;
+
+typedef enum {
+	DISPCFG_EV_PENDING = IPC_FIRST_USER_METHOD
+} dispcfg_event_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/dispcfg/include/types/dispcfg.h
===================================================================
--- uspace/lib/dispcfg/include/types/dispcfg.h	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
+++ uspace/lib/dispcfg/include/types/dispcfg.h	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -0,0 +1,90 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libdispcfg
+ * @{
+ */
+/** @file
+ */
+
+#ifndef _LIBDISPCFG_TYPES_DISPCFG_H_
+#define _LIBDISPCFG_TYPES_DISPCFG_H_
+
+#include <ipc/services.h>
+#include <types/common.h>
+
+/** Use the default display configuration service (argument to dispcfg_open() */
+#define DISPCFG_DEFAULT SERVICE_NAME_DISPCFG
+
+struct dispcfg;
+
+/** Display configuration session */
+typedef struct dispcfg dispcfg_t;
+
+/** Display configuration callbacks */
+typedef struct {
+	/** Seat added */
+	void (*seat_added)(void *, sysarg_t);
+	/** Seat removed */
+	void (*seat_removed)(void *, sysarg_t);
+} dispcfg_cb_t;
+
+/** Display configuration event type */
+typedef enum {
+	/** Seat added */
+	dcev_seat_added,
+	/** Seat removed */
+	dcev_seat_removed,
+} dispcfg_ev_type_t;
+
+/** Display configuration event */
+typedef struct {
+	/** Event type */
+	dispcfg_ev_type_t etype;
+	/** Seat ID */
+	sysarg_t seat_id;
+} dispcfg_ev_t;
+
+/** Seat list */
+typedef struct {
+	/** Number of seats */
+	size_t nseats;
+	/** ID for each seat */
+	sysarg_t *seats;
+} dispcfg_seat_list_t;
+
+/** Seat information */
+typedef struct {
+	/** Seat name */
+	char *name;
+} dispcfg_seat_info_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/dispcfg/meson.build
===================================================================
--- uspace/lib/dispcfg/meson.build	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
+++ uspace/lib/dispcfg/meson.build	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -0,0 +1,37 @@
+#
+# Copyright (c) 2023 Jiri Svoboda
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+src = files(
+	'src/dispcfg.c',
+	'src/dispcfg_srv.c',
+)
+
+test_src = files(
+	'test/main.c',
+	'test/dispcfg.c',
+)
Index: uspace/lib/dispcfg/private/dispcfg.h
===================================================================
--- uspace/lib/dispcfg/private/dispcfg.h	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
+++ uspace/lib/dispcfg/private/dispcfg.h	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -0,0 +1,61 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libdispcfg
+ * @{
+ */
+/** @file
+ */
+
+#ifndef _LIBDISPCFG_PRIVATE_DISPCFG_H_
+#define _LIBDISPCFG_PRIVATE_DISPCFG_H_
+
+#include <async.h>
+#include <fibril_synch.h>
+#include <stdbool.h>
+
+/** Display configuration session structure */
+struct dispcfg {
+	/** Session with display configuration service */
+	async_sess_t *sess;
+	/** Callbacks */
+	dispcfg_cb_t *cb;
+	/** Calback argument */
+	void *cb_arg;
+	/** Synchronize access to display configuration object */
+	fibril_mutex_t lock;
+	/** @c true if callback handler terminated */
+	bool cb_done;
+	/** Signalled when cb_done or ev_pending is changed */
+	fibril_condvar_t cv;
+};
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/dispcfg/src/dispcfg.c
===================================================================
--- uspace/lib/dispcfg/src/dispcfg.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
+++ uspace/lib/dispcfg/src/dispcfg.c	(revision e04b72d69126c4074644c19c920bf771d9c72a1e)
@@ -0,0 +1,452 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libdispcfg
+ * @{
+ */
+/**
+ * @file
+ * @brief Display configuration protocol client
+ */
+
+#include <async.h>
+#include <dispcfg.h>
+#include <errno.h>
+#include <fibril_synch.h>
+#include <ipc/dispcfg.h>
+#include <ipc/services.h>
+#include <loc.h>
+#include <mem.h>
+#include <stdlib.h>
+#include <str.h>
+#include "../private/dispcfg.h"
+
+static errno_t dispcfg_callback_create(dispcfg_t *);
+static void dispcfg_cb_conn(ipc_call_t *, void *);
+
+/** Open display configuration service.
+ *
+ * @param wmname Display configuration service name or @c NULL to use default
+ * @param cb Display configuration callbacks
+ * @param cb_arg Callback argument
+ * @param rdispcfg Place to store pointer to display configuration session
+ * @return EOK on success or an error code
+ */
+errno_t dispcfg_open(const char *wmname, dispcfg_cb_t *cb, void *cb_arg,
+    dispcfg_t **rdispcfg)
+{
+	service_id_t dispcfg_svc;
+	dispcfg_t *dispcfg;
+	errno_t rc;
+
+	dispcfg = calloc(1, sizeof(dispcfg_t));
+	if (dispcfg == NULL)
+		return ENOMEM;
+
+	dispcfg->cb = cb;
+	dispcfg->cb_arg = cb_arg;
+
+	fibril_mutex_initialize(&dispcfg->lock);
+	fibril_condvar_initialize(&dispcfg->cv);
+
+	if (wmname == NULL)
+		wmname = SERVICE_NAME_DISPCFG;
+
+	rc = loc_service_get_id(wmname, &dispcfg_svc, 0);
+	if (rc != EOK) {
+		free(dispcfg);
+		return ENOENT;
+	}
+
+	dispcfg->sess = loc_service_connect(dispcfg_svc, INTERFACE_DISPCFG,
+	    0);
+	if (dispcfg->sess == NULL) {
+		free(dispcfg);
+		return ENOENT;
+	}
+
+	rc = dispcfg_callback_create(dispcfg);
+	if (rc != EOK) {
+		async_hangup(dispcfg->sess);
+		free(dispcfg);
+		return EIO;
+	}
+
+	*rdispcfg = dispcfg;
+	return EOK;
+}
+
+/** Create callback connection from display configuration service.
+ *
+ * @param dispcfg Display configuration
+ * @return EOK on success or an error code
+ */
+static errno_t dispcfg_callback_create(dispcfg_t *dispcfg)
+{
+	async_exch_t *exch = async_exchange_begin(dispcfg->sess);
+
+	aid_t req = async_send_0(exch, DISPCFG_CALLBACK_CREATE, NULL);
+
+	port_id_t port;
+	errno_t rc = async_create_callback_port(exch, INTERFACE_DISPCFG_CB, 0, 0,
+	    dispcfg_cb_conn, dispcfg, &port);
+
+	async_exchange_end(exch);
+
+	if (rc != EOK)
+		return rc;
+
+	errno_t retval;
+	async_wait_for(req, &retval);
+
+	return retval;
+}
+
+/** Close display configuration service.
+ *
+ * @param dispcfg Display configuration
+ */
+void dispcfg_close(dispcfg_t *dispcfg)
+{
+	fibril_mutex_lock(&dispcfg->lock);
+	async_hangup(dispcfg->sess);
+	dispcfg->sess = NULL;
+
+	/* Wait for callback handler to terminate */
+
+	while (!dispcfg->cb_done)
+		fibril_condvar_wait(&dispcfg->cv, &dispcfg->lock);
+	fibril_mutex_unlock(&dispcfg->lock);
+
+	free(dispcfg);
+}
+
+/** Get seat list.
+ *
+ * @param dispcfg Display configuration
+ * @param rlist Place to store pointer to new seat list structure
+ * @return EOK on success or an error code
+ */
+errno_t dispcfg_get_seat_list(dispcfg_t *dispcfg, dispcfg_seat_list_t **rlist)
+{
+	async_exch_t *exch;
+	aid_t req;
+	ipc_call_t answer;
+	dispcfg_seat_list_t *list;
+	sysarg_t nseats;
+	sysarg_t *seats;
+	errno_t rc;
+
+	exch = async_exchange_begin(dispcfg->sess);
+	req = async_send_0(exch, DISPCFG_GET_SEAT_LIST, &answer);
+
+	/* Receive seat list length */
+	rc = async_data_read_start(exch, &nseats, sizeof (nseats));
+	if (rc != EOK) {
+		async_exchange_end(exch);
+		async_wait_for(req, &rc);
+		return rc;
+	}
+
+	seats = calloc(nseats, sizeof(sysarg_t));
+	if (seats == NULL) {
+		async_exchange_end(exch);
+		async_forget(req);
+		return ENOMEM;
+	}
+
+	/* Receive seat list */
+	rc = async_data_read_start(exch, seats, nseats * sizeof (sysarg_t));
+	async_exchange_end(exch);
+
+	if (rc != EOK) {
+		async_forget(req);
+		return rc;
+	}
+
+	async_wait_for(req, &rc);
+	if (rc != EOK)
+		return rc;
+
+	list = calloc(1, sizeof(dispcfg_seat_list_t));
+	if (list == NULL)
+		return ENOMEM;
+
+	list->nseats = nseats;
+	list->seats = seats;
+	*rlist = list;
+	return EOK;
+}
+
+/** Free seat list.
+ *
+ * @param list Display configuration list
+ */
+void dispcfg_free_seat_list(dispcfg_seat_list_t *list)
+{
+	free(list->seats);
+	free(list);
+}
+
+/** Get seat information.
+ *
+ * @param dispcfg Display configuration
+ * @param seat_id Seat ID
+ * @param rinfo Place to store pointer to new seat information structure
+ * @return EOK on success or an error code
+ */
+errno_t dispcfg_get_seat_info(dispcfg_t *dispcfg, sysarg_t seat_id,
+    dispcfg_seat_info_t **rinfo)
+{
+	async_exch_t *exch;
+	aid_t req;
+	ipc_call_t answer;
+	dispcfg_seat_info_t *info;
+	sysarg_t namesize;
+	char *name;
+	errno_t rc;
+
+	exch = async_exchange_begin(dispcfg->sess);
+	req = async_send_1(exch, DISPCFG_GET_SEAT_INFO, seat_id, &answer);
+
+	/* Receive name size */
+	rc = async_data_read_start(exch, &namesize, sizeof (namesize));
+	if (rc != EOK) {
+		async_exchange_end(exch);
+		async_wait_for(req, &rc);
+		return rc;
+	}
+
+	name = calloc(namesize + 1, sizeof(char));
+	if (name == NULL) {
+		async_exchange_end(exch);
+		async_forget(req);
+		return ENOMEM;
+	}
+
+	/* Receive name */
+	rc = async_data_read_start(exch, name, namesize);
+	async_exchange_end(exch);
+
+	if (rc != EOK) {
+		async_forget(req);
+		return rc;
+	}
+
+	async_wait_for(req, &rc);
+	if (rc != EOK)
+		return rc;
+
+	/* Null-terminate the string */
+	name[namesize] = '\0';
+
+	info = calloc(1, sizeof(dispcfg_seat_info_t));
+	if (info == NULL)
+		return ENOMEM;
+
+	info->name = name;
+	*rinfo = info;
+	return EOK;
+}
+
+/** Free seat information.
+ *
+ * @param info Display configuration information
+ */
+void dispcfg_free_seat_info(dispcfg_seat_info_t *info)
+{
+	free(info->name);
+	free(info);
+}
+
+/** Create seat.
+ *
+ * @param dispcfg Display configuration session
+ * @param name Seat name
+ * @param rseat_id Place to store ID of the new seat
+ * @return EOK on success or an error code
+ */
+errno_t dispcfg_seat_create(dispcfg_t *dispcfg, const char *name,
+    sysarg_t *rseat_id)
+{
+	async_exch_t *exch;
+	aid_t req;
+	ipc_call_t answer;
+	size_t name_size;
+	errno_t rc;
+
+	name_size = str_size(name);
+
+	exch = async_exchange_begin(dispcfg->sess);
+	req = async_send_0(exch, DISPCFG_SEAT_CREATE, &answer);
+
+	/* Write name */
+	rc = async_data_write_start(exch, name, name_size);
+	async_exchange_end(exch);
+	if (rc != EOK) {
+		async_forget(req);
+		return rc;
+	}
+
+	async_wait_for(req, &rc);
+	if (rc != EOK)
+		return rc;
+
+	*rseat_id = ipc_get_arg1(&answer);
+	return EOK;
+}
+
+/** Delete seat.
+ *
+ * @param dispcfg Display configuration
+ * @param seat_id Seat ID
+ * @return EOK on success or an error code
+ */
+errno_t dispcfg_seat_delete(dispcfg_t *dispcfg, sysarg_t seat_id)
+{
+	async_exch_t *exch;
+	errno_t rc;
+
+	exch = async_exchange_begin(dispcfg->sess);
+	rc = async_req_1_0(exch, DISPCFG_SEAT_DELETE, seat_id);
+
+	async_exchange_end(exch);
+	return rc;
+}
+
+/** Get display configuration event.
+ *
+ * @param dispcfg Display configuration
+ * @param event Place to store event
+ * @return EOK on success or an error code
+ */
+static errno_t dispcfg_get_event(dispcfg_t *dispcfg, dispcfg_ev_t *event)
+{
+	async_exch_t *exch;
+	ipc_call_t answer;
+	aid_t req;
+	errno_t rc;
+
+	exch = async_exchange_begin(dispcfg->sess);
+	req = async_send_0(exch, DISPCFG_GET_EVENT, &answer);
+	rc = async_data_read_start(exch, event, sizeof(*event));
+	async_exchange_end(exch);
+	if (rc != EOK) {
+		async_forget(req);
+		return rc;
+	}
+
+	async_wait_for(req, &rc);
+	if (rc != EOK)
+		return rc;
+
+	return EOK;
+}
+
+/** Display configuration events are pending.
+ *
+ * @param dispcfg Display configuration
+ * @param icall Call data
+ */
+static void dispcfg_ev_pending(dispcfg_t *dispcfg, ipc_call_t *icall)
+{
+	errno_t rc;
+	dispcfg_ev_t event;
+
+	while (true) {
+		fibril_mutex_lock(&dispcfg->lock);
+
+		if (dispcfg->sess != NULL)
+			rc = dispcfg_get_event(dispcfg, &event);
+		else
+			rc = ENOENT;
+
+		fibril_mutex_unlock(&dispcfg->lock);
+
+		if (rc != EOK)
+			break;
+
+		switch (event.etype) {
+		case dcev_seat_added:
+			if (dispcfg->cb != NULL &&
+			    dispcfg->cb->seat_added != NULL) {
+				dispcfg->cb->seat_added(dispcfg->cb_arg,
+				    event.seat_id);
+			}
+			break;
+		case dcev_seat_removed:
+			if (dispcfg->cb != NULL &&
+			    dispcfg->cb->seat_removed != NULL) {
+				dispcfg->cb->seat_removed(dispcfg->cb_arg,
+				    event.seat_id);
+			}
+			break;
+		}
+	}
+
+	async_answer_0(icall, EOK);
+}
+
+/** Callback connection handler.
+ *
+ * @param icall Connect call data
+ * @param arg   Argument, dispcfg_t *
+ */
+static void dispcfg_cb_conn(ipc_call_t *icall, void *arg)
+{
+	dispcfg_t *dispcfg = (dispcfg_t *) arg;
+
+	while (true) {
+		ipc_call_t call;
+		async_get_call(&call);
+
+		if (!ipc_get_imethod(&call)) {
+			/* Hangup */
+			async_answer_0(&call, EOK);
+			goto out;
+		}
+
+		switch (ipc_get_imethod(&call)) {
+		case DISPCFG_EV_PENDING:
+			dispcfg_ev_pending(dispcfg, &call);
+			break;
+		default:
+			async_answer_0(&call, ENOTSUP);
+			break;
+		}
+	}
+
+out:
+	fibril_mutex_lock(&dispcfg->lock);
+	dispcfg->cb_done = true;
+	fibril_mutex_unlock(&dispcfg->lock);
+	fibril_condvar_broadcast(&dispcfg->cv);
+}
+
+/** @}
+ */
